Coin: SoGLCacheContextElement Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

SoGLCacheContextElement Class Reference
Element Classes

The SoGLCacheContextElement class handles the OpenGL cache for a context. More...

`#include <Inventor/elements/SoGLCacheContextElement.h>`

Inheritance diagram for SoGLCacheContextElement:

## Public Types
enum | { DO_AUTO_CACHE = 1 , DONT_AUTO_CACHE }

## Public Member Functions
virtual void | init (SoState *state)
virtual SbBool | matches (const SoElement *elt) const
virtual SoElement * | copyMatchInfo (void) const
Public Member Functions inherited from SoElement
const SoType | getTypeId (void) const
int | getStackIndex (void) const
virtual void | push (SoState *state)
virtual void | pop (SoState *state, const SoElement *prevTopElement)
void | setDepth (const int depth)
int | getDepth (void) const
virtual void | print (FILE *file=stdout) const
virtual | ~SoElement ()

## Static Public Member Functions
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void * | createInstance (void)
static void | initClass (void)
static void | set (SoState *state, int context, SbBool twopasstransparency, SbBool remoterendering)
static int | get (SoState *state)
static int | getExtID (const char *str)
static void | getOpenGLVersion (SoState *state, int &major, int &minor)
static SbBool | extSupported (SoState *state, int extid)
static SbBool | areMipMapsFast (SoState *state)
static void | shouldAutoCache (SoState *state, int bits)
static void | setAutoCacheBits (SoState *state, int bits)
static int | resetAutoCacheBits (SoState *state)
static SbBool | getIsRemoteRendering (SoState *state)
static uint32_t | getUniqueCacheContext (void)
static void | scheduleDeleteCallback (const uint32_t contextid, SoScheduleDeleteCB *cb, void *closure)
static void | incNumShapes (SoState *state)
static int | getNumShapes (SoState *state)
static void | incNumSeparators (SoState *state)
static int | getNumSeparators (SoState *state)
Static Public Member Functions inherited from SoElement
static void | initClass (void)
static SoType | getClassTypeId (void)
static int | getClassStackIndex (void)
static void | initElements (void)
static int | getNumStackIndices (void)
static SoType | getIdFromStackIndex (const int stackIndex)

## Protected Member Functions
virtual | ~SoGLCacheContextElement ()
Protected Member Functions inherited from SoElement
| SoElement (void)
void | capture (SoState *const state) const
virtual void | captureThis (SoState *state) const
void | setTypeId (const SoType typeId)
void | setStackIndex (const int index)
SoElement * | getNextInStack (void) const
SoElement * | getNextFree (void) const

## Additional Inherited Members
Static Protected Member Functions inherited from SoElement
static SoElement * | getElement (SoState *const state, const int stackIndex)
static const SoElement * | getConstElement (SoState *const state, const int stackIndex)
static int | createStackIndex (const SoType id)
Protected Attributes inherited from SoElement
SoType | typeId
int | stackIndex
int | depth
Static Protected Attributes inherited from SoElement
static int | classStackIndex
static SoTypeList * | stackToType

## Detailed Description

The SoGLCacheContextElement class handles the OpenGL cache for a context.

## Constructor & Destructor Documentation

## ◆ ~SoGLCacheContextElement()

SoGLCacheContextElement::~SoGLCacheContextElement | ( |  | ) |
| protectedvirtual

Destructor.

## Member Function Documentation

## ◆ getClassTypeId()

SoType SoGLCacheContextElement::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ getClassStackIndex()

int SoGLCacheContextElement::getClassStackIndex | ( | void |  | ) |
| static

This static method returns the state stack index for the class.

## ◆ createInstance()

void * SoGLCacheContextElement::createInstance | ( | void |  | ) |
| static

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Creates a new instance of the class type corresponding to the SoType object.

## ◆ initClass()

void SoGLCacheContextElement::initClass | ( | void |  | ) |
| static

Initialize relevant common data for all instances, like the type system.

## ◆ init()

void SoGLCacheContextElement::init | ( | SoState * | state | ) |
| virtual

This function initializes the element type in the given SoState. It is called for the first element of each enabled element type in SoState objects.

Reimplemented from SoElement.

## ◆ matches()

SbBool SoGLCacheContextElement::matches | ( | const SoElement * | element | ) | const
| virtual

This function returns `TRUE` is the element matches another element (of the same class), with respect to cache validity.

If the application programmer's extension element has a matches() function, it should also have a copyMatchInfo() function.

Implements SoElement.

## ◆ copyMatchInfo()

SoElement * SoGLCacheContextElement::copyMatchInfo | ( | void |  | ) | const
| virtual

This function creates a copy of the element that contains enough information to enable the matches() function to work.

Used to help with scene graph traversal caching operations.

Implements SoElement.

## ◆ set()

void SoGLCacheContextElement::set | ( | SoState * | state,
|  | int | context,
|  | SbBool | twopasstransparency,
|  | SbBool | remoterendering )
| static

Sets data for context.

## ◆ get()

int SoGLCacheContextElement::get | ( | SoState * | state | ) |
| static

Returns context id.

Note that the signature on this function is slightly wrong: the function should really return an `uint32_t`, like SoGLRenderAction::getCacheContext() does. It is kept like this for compatibility reasons.

The value returned will always be a positive integer.

## ◆ getExtID()

int SoGLCacheContextElement::getExtID | ( | const char * | str | ) |
| static

Returns an extension id based on the GL extension string. The extension id can be used to quickly test for the availability of an extension later, using extSupported().

## ◆ getOpenGLVersion()

void SoGLCacheContextElement::getOpenGLVersion | ( | SoState * | state,
|  | int & | major,
|  | int & | minor )
| static

Returns the OpenGL version for the current context. This method is an extension versus the Open Inventor API.

## ◆ extSupported()

SbBool SoGLCacheContextElement::extSupported | ( | SoState * | state,
|  | int | extid )
| static

Returns TRUE if the extension is supported for the current context. extid must be an id returned from getExtId(). The test result is cached so this method is pretty fast and can be used at runtime.

## ◆ areMipMapsFast()

SbBool SoGLCacheContextElement::areMipMapsFast | ( | SoState * | state | ) |
| static

Returns if mipmapped textures are fast for the current context. In Coin, we just return TRUE for the moment.

## ◆ shouldAutoCache()

void SoGLCacheContextElement::shouldAutoCache | ( | SoState * | state,
|  | int | bits )
| static

Update auto cache bits.

## ◆ setAutoCacheBits()

void SoGLCacheContextElement::setAutoCacheBits | ( | SoState * | state,
|  | int | bits )
| static

Sets the auto cache bits.

## ◆ resetAutoCacheBits()

int SoGLCacheContextElement::resetAutoCacheBits | ( | SoState * | state | ) |
| static

Not properly supported yet.

## ◆ getIsRemoteRendering()

SbBool SoGLCacheContextElement::getIsRemoteRendering | ( | SoState * | state | ) |
| static

Returns `TRUE` if rendering is indirect / remote.

## ◆ getUniqueCacheContext()

uint32_t SoGLCacheContextElement::getUniqueCacheContext | ( | void |  | ) |
| static

Returns an unique cache context id, in the range [1, ->.

If you render the same scene graph into two or different cache contexts, and you've not using display list and texture object sharing among contexts, the cache context id need to be unique for rendering to work.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

See also
  SoGLRenderAction::setCacheContext()

## ◆ scheduleDeleteCallback()

void SoGLCacheContextElement::scheduleDeleteCallback | ( | const uint32_t | contextid,
|  | SoScheduleDeleteCB * | cb,
|  | void * | closure )
| static

Can be used to receive a callback the next time Coin knows that the context (specified by contextid) is the current OpenGL context.

This function can be used to free OpenGL resources for a context.

Note that the callback will be invoked only once, and then removed from the internal list of scheduled callbacks.

Since
  Coin 2.3

## ◆ incNumShapes()

void SoGLCacheContextElement::incNumShapes | ( | SoState * | state | ) |
| static

Increment the number of shapes in a open cache.

Since
  Coin 3.0

## ◆ getNumShapes()

int SoGLCacheContextElement::getNumShapes | ( | SoState * | state | ) |
| static

Returns the number of shapes in an open cache.

Since
  Coin 3.0

## ◆ incNumSeparators()

void SoGLCacheContextElement::incNumSeparators | ( | SoState * | state | ) |
| static

Increment the number of separators in an open cache.

Since
  Coin 3.0

## ◆ getNumSeparators()

int SoGLCacheContextElement::getNumSeparators | ( | SoState * | state | ) |
| static

Returns the number of separators in an open cache.

Since
  Coin 3.0

The documentation for this class was generated from the following files:

- SoGLCacheContextElement.h
- SoGLCacheContextElement.cpp